#ifndef _INLINE_FIFO_H
#define _INLINE_FIFO_H

#ifndef __INLINE_MACROS_H
#include <inline/macros.h>
#endif

#ifndef FIFO_BASE_NAME
#define FIFO_BASE_NAME FifoBase
#endif

#define BufSizeFifo(fifo) \
	LP1(0x3c, long, BufSizeFifo, FifoHan, fifo, d0, \
	, FIFO_BASE_NAME)

#define CloseFifo(fifo, flags) \
	LP2NR(0x24, CloseFifo, FifoHan, fifo, d0, long, flags, d1, \
	, FIFO_BASE_NAME)

#define OpenFifo(name, bytes, flags) \
	LP3(0x1e, FifoHan, OpenFifo, char *, name, d0, long, bytes, d1, long, flags, a0, \
	, FIFO_BASE_NAME)

#define ReadFifo(fifo, buf, bytes) \
	LP3(0x2a, long, ReadFifo, FifoHan, fifo, d0, char **, buf, d1, long, bytes, a0, \
	, FIFO_BASE_NAME)

#define RequestFifo(fifo, msg, req) \
	LP3NR(0x36, RequestFifo, FifoHan, fifo, d0, struct Message *, msg, d1, long, req, a0, \
	, FIFO_BASE_NAME)

#define WriteFifo(fifo, buf, bytes) \
	LP3(0x30, long, WriteFifo, FifoHan, fifo, d0, char *, buf, d1, long, bytes, a0, \
	, FIFO_BASE_NAME)

#endif /* _INLINE_FIFO_H */
